HDU1385 Minimum Transport Cost

Minimum Transport Cost

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 9052    Accepted Submission(s): 2383

Problem Description

These are N cities in Spring country. Between each pair of cities there may be one transportation track or none. Now there is some cargo that should be delivered from one city to another. The transportation fee consists of two parts: 
The cost of the transportation on the path between these cities, and

a certain tax which will be charged whenever any cargo passing through one city, except for the source and the destination cities.
You must write a program to find the route which has the minimum cost.

Input

First is N, number of cities. N = 0 indicates the end of input.
The data of path cost, city tax, source and destination cities are given in the input, which is of the form:

a11 a12 ... a1N
a21 a22 ... a2N
...............
aN1 aN2 ... aNN
b1 b2 ... bN

c d
e f
...
g h

where aij is the transport cost from city i to city j, aij = -1 indicates there is no direct path between city i and city j. bi represents the tax of passing through city i. And the cargo is to be delivered from city c to city d, city e to city f, ..., and g = h = -1. You must output the sequence of cities passed by and the total cost which is of the form:

Output

From c to d :
Path: c-->c1-->......-->ck-->d
Total cost : ......
......

From e to f :
Path: e-->e1-->..........-->ek-->f
Total cost : ......

Note: if there are more minimal paths, output the lexically smallest one. Print a blank line after each test case.

Sample Input

5

0 3 22 -1 4

3 0 5 -1 -1

22 5 0 9 20

-1 -1 9 0 4

4 -1 20 4 0

5 17 8 3 1

1 3

3 5

2 4

-1 -1

0

Sample Output

From 1 to 3 :

Path: 1-->5-->4-->3

Total cost : 21

From 3 to 5 :

Path: 3-->4-->5

Total cost : 16

From 2 to 4 :

Path: 2-->1-->5-->4

Total cost : 17

Source

Asia 1996, Shanghai (Mainland China)

题意,给一张n*n的地图,-1表示不联通,正整数为边权,每个点有点权,给定起点s和终点t,s到t的代价是经过的边权和加上路径上除了s和t的点权和,求s到t的最短路并输出路径

思路:floyd,path[i][j]表示i到j路径上的第一个点

/*
ID: LinKArftc
PROG: 1385.cpp
LANG: C++
*/

#include <map>
#include <set>
#include <cmath>
#include <stack>
#include <queue>
#include <vector>
#include <cstdio>
#include <string>
#include <utility>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;
#define eps 1e-8
#define randin srand((unsigned int)time(NULL))
#define input freopen("input.txt","r",stdin)
#define debug(s) cout << "s = " << s << endl;
#define outstars cout << "*************" << endl;
const double PI = acos(-1.0);
const double e = exp(1.0);
const int inf = 0x3f3f3f3f;
const int INF = 0x7fffffff;
typedef long long ll;

const int maxn = 100;

int mp[maxn][maxn];
int path[maxn][maxn];//path[i][j]记录从i到j的下一个点
int tax[maxn];
int n, s, t;

void floyd() {
    for (int k = 1; k <= n; k ++) {
        for (int i = 1; i <= n; i ++) {
            for (int j = 1; j <= n; j ++) {
                if (i == k || j == k) continue;
                int tmp = mp[i][k] + mp[k][j] + tax[k];
                if (mp[i][j] > tmp) {
                    mp[i][j] = tmp;
                    path[i][j] = path[i][k];
                } else if (mp[i][j] == tmp) {
                    path[i][j] = min(path[i][j], path[i][k]);
                }
            }
        }
    }
}

void print_path() {
    printf("Path: %d", s);
    int cur = s;
    while (cur != t) {
        cur = path[cur][t];
        printf("-->%d", cur);
    }
    printf("\n");
}

int main() {
    while (~scanf("%d", &n) && n) {
        for (int i = 1; i <= n; i ++) {
            for (int j = 1; j <= n; j ++) {
                scanf("%d", &mp[i][j]);
                if (mp[i][j] == -1) mp[i][j] = inf;//最好用inf替换,用-1的话特判很容易错
                else path[i][j] = j;
            }
        }
        for (int i = 1; i <= n; i ++) scanf("%d", &tax[i]);
        floyd();
        while (~scanf("%d %d", &s, &t)) {
            if (s == -1 && t == -1) break;
            printf("From %d to %d :\n", s, t);
            print_path();
            printf("Total cost : %d\n\n", mp[s][t]);
        }
    }

    return 0;
}
时间: 2024-08-06 07:50:28

HDU1385 Minimum Transport Cost的相关文章

HDU1385 Minimum Transport Cost 【Floyd】+【路径记录】

Minimum Transport Cost Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 7496    Accepted Submission(s): 1918 Problem Description These are N cities in Spring country. Between each pair of cities

hdu1385 Minimum Transport Cost 字典序最小的最短路径 Floyd

求最短路的算法最有名的是Dijkstra.所以一般拿到题目第一反应就是使用Dijkstra算法.但是此题要求的好几对起点和终点的最短路径.所以用Floyd是最好的选择.因为其他三种最短路的算法都是单源的. 输出字典序最小的路径则需要修改模版. #include<iostream> #include<cstdio> #include<cstring> #include<algorithm> using namespace std; const int N =1

[floyd+路径输出]HDU1385 Minimum Transport Cost

题目链接 题目翻译: 有N个城市,然后直接给出这些城市之间的邻接矩阵,矩阵中-1代表那两个城市无道路相连,其他值代表路径长度. 如果一辆汽车经过某个城市,必须要交一定的钱(可能是过路费). 现在要从a城到b城,花费为路径长度之和,再加上除起点与终点外所有城市的过路费之和. 求最小花费,如果有多条路经符合,则输出字典序最小的路径. 思考 题目给的是邻接矩阵存图,而且给出X个提问.大概率用Floyd写是比较好的,字典序最小实现的话. 用Path数组实现 表示点i到j经过的第一个点 #include

HDU1385 Minimum Transport Cost(最短路输出路径)

题意:先给你一张你n * n的图,代表城市间的距离,然后,给出n个tax的费用,然后很多询问,问你a到b的最少费用,并且打印路径(字典序) 注意tax的费用起点和终点不算 逆序spfa: #include<iostream> #include<deque> #include<vector> #include<algorithm> #include<list> #include<cstdio> using namespace std;

HDU 1385 Minimum Transport Cost 最短路径题解

本题就是使用Floyd算法求所有路径的最短路径,并且需要保存路径,而且更进一步需要按照字典顺序输出结果. 还是有一定难度的. Floyd有一种很巧妙的记录数据的方法,大多都是使用这个方法记录数据的. 不过其实本题数据不是很大,一般太大的数据也无法使用Floyd,因为效率是O(N^3). 所以其实也可以使用一般的Floyd算法,然后增加个三维数组记录数据.下面就是这种做法,0ms过了. #include <stdio.h> #include <vector> using std::v

HDU 1385 Minimum Transport Cost(Floyd 最短路 打印路径)

HDU 1385 大意: 有N个城市,然后直接给出这些城市之间的邻接矩阵,矩阵中-1代表那两个城市无道路相连,其他值代表路径长度. 如果一辆汽车经过某个城市,必须要交一定的钱(可能是过路费). 现在要从a城到b城,花费为路径长度之和,再加上除起点与终点外所有城市的过路费之和. 求最小花费,如果有多条路经符合,则输出字典序最小的路径. 思路: Floyd求最短路,打印路径即可. 1 /*--------------------------------------------------------

zoj1456 Minimum Transport Cost

http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemCode=1456 题目大意:有N个城市,两个城市之间要么有一条运输路线,要么没有.现在有一些货物需要从一个城市运往另一个城市.运输费用包含两部分:通过两个城市之间运输线路的费用,以及通过一个城市时的纳税(起点城市和目标城市除外).要求输出费用最小,并且路径字典需序最小的线路. 所谓字典序就是,如果有1-->2-->和1-->3两条路可选当输出1-->2-->3.

hdu Minimum Transport Cost(按字典序输出路径)

 摘自:Think In Java 从技术角度说,OOP(面向对象程序设计)只是涉及抽象的数据类型.继承以及多形性,但另一些问题也可能显得非常重要.本节将就这些问题进行探讨.最重要的问题之一是对象的创建及破坏方式.对象需要的数据位于哪儿,如何控制对象的"存在时间"呢?针对这个问题,解决的方案是各异其趣的.C++认为程序的执行效率是最重要的一个问题,所以它允许程序员作出选择.为获得最快的运行速度,存储以及存在时间可在编写程序时决定,只需将对象放置在堆栈(有时也叫作自动或定域变量)或者静态

hdu 1385 Minimum Transport Cost (Floyd + 字典序打印路径)

Minimum Transport Cost Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 7822    Accepted Submission(s): 2028 Problem Description These are N cities in Spring country. Between each pair of cities